Subject: Re: Re: Re: Modules not loading with asun2.1.4pre39

From: "jeff b" <[email-masked]>
Date: Wed, 07 Jun 2000 14:38:46 +0000 (GMT)

On Tue, 6 Jun 2000 Dejan Muhamedagic  wrote:
> On Tue, Jun 06, 2000 at 08:12:17PM +0000, jeff b wrote:
> > > I ldd'd the modules, and it turns out that uams_randnum.so and
> > > uams_guest.so (the two modules that work) are for some reason
> > > statically linked. Any idea why they are, or why this could be
> > > causing problems? Even the cleartext modules aren't working. I didn't
> > > see anything in the etc/uams/Makefile to indicate static compilation
> > > of specific modules...
> 
> I don't think that this is a culprit.  But it may be a hint.
> The reason is probably that those which happened to be statically
> linked don't use any functions from other libraries (i.e. they're
> more or less empty and pretty useless).  Use nm(1) to see the list
> of defined symbols.  In particular uam_setup should be present.
> Each of uams which doesn't contain uam_setup function has probably
> been excluded in the Makefile with #define (or a lack of one).
> Perhaps you should check the top level Makefile one more time.  I
> think that between versions 2.1.4-37b and 39_test some #defines in
> respect to authentication have changed defaults.  At the moment I
> can't help you any more because I don't have a working netatalk
> here.  I should be able to check it out tomorrow.

I tried adding the extra libraries for PAM, which didn't seem to do very
much... it had already defined -DUAM_PAM for the PAM specific modules.

This is really strange. Now uams_randnum is compiling as shared. It looks
like the only difference between uams_guest and the others is that
uams_guest is not linked with any other modules (-lpam or anything like
that) and therefore is statically linked, even though ld is called with
-shared. This might be a red herring, though.
 
> BTW, I may have been wrong when I said that error should be
> reported if the module was specified and wasn't loaded.  Not sure
> anymore.

They definately aren't being loaded, but there doesn't seem to be any
reason for it that I can find. I've had this problem with
1.4b2+asun2.1.4pre3{7,8,9}.
     
*************************
jeff b
system administrator
university communications
university of connecticut
[email-masked]